#include <stdio.h>
#include <stdlib.h>
#include "types.h"

#define MAX_SIGN_LEN 16

FILE* fpipe = NULL;
FILE* outfile = NULL;
_UINT64 sincelast = 0;
_UINT64 ip, ebp, sp, sign, thread_id, addr;
_UINT64 sign_size = 0;
_UINT64 sndSignArr[MAX_SIGN_LEN];
char type = 'x', valid = 'N';
_UINT64 i = 0, sig_len = 0;  	
int num = 0;
char lt, gt;	
_UINT64 val = 0;

int main(int argc, char** argv)
{
  if(argc < 2)
  {
	printf("\nusage: extract <input_file>");
	exit(-1);
  }
 		
  if((fpipe = fopen(argv[1], "r"))== NULL)
  {
   printf("file/pipe %s not present....:!exiting\n", argv[1]);
   return -1;
  }

  while(1)
  {
	num = fscanf(fpipe,"\n*%ld*", &sign_size);
	//printf("sign_size = %ld", sign_size);getchar();
   	if(num == 0 || num == -1){printf("\nEOF reached or ERROR#1....%d\n",num);goto TRACES_END;}
	sig_len = sign_size;
	if(sig_len > MAX_SIGN_LEN || sig_len < 0)
	{ 
		printf("\nSign length %d exceeded the limit %d, exiting", sig_len, MAX_SIGN_LEN);
		sig_len = MAX_SIGN_LEN;
	}
	num = fscanf(fpipe,"\n%c", &lt);
   	if(num == 0 || num == -1){printf("\nEOF reached or ERROR#2....%d\n",num);goto TRACES_END;}
	for(i = 0; i < sig_len; i++)
	{
		fscanf(fpipe, " %20p", &val);
   		if(num == 0 || num == -1){printf("\nEOF reached or ERROR#3....%d\n",num);goto TRACES_END;}
		/* ignore top most level of sign */
		//if(i)
  		{	sndSignArr[i] = val;	}
		//fprintf(stdout, "% 20p", (void*)val);
	}
	fscanf(fpipe, "%c\n", &gt);
   	if(num == 0 || num == -1){printf("\nEOF reached or ERROR#4....%d\n",num);goto TRACES_END;}
	
	num = fscanf(fpipe,"ip:%20p ebp:%20p sp:%20p sign: %20p tid:%4u %c %c addr:%20p %u\n",
              &ip,     &ebp,     &sp,     &sign,      &thread_id, &type, &valid, &addr, &sincelast);

   	/*	
	   fprintf(outfile,"ip:%20p ebp:%20p sp:%20p sign: %20p tid:%4u %c %c addr:%20p %u\n",
                     ip,     ebp,     sp,     sign,      thread_id, type, valid, addr, sincelast);
   	*/
	fprintf(stdout, "Sign:");
	for( i = 0; i < sig_len; i++)
	{
		fprintf(stdout, "%p ", (void*)sndSignArr[i]);
	}
	fprintf(stdout, "\n");
	TRACES_END:  
	if(num == 0 || num == -1)
	{
		printf("\nEOF reached or ERROR....%d\n",num);
		break;
	}
   }	

	return 0;
}
